<?php

class fbauth_fb {

  var $fb_app_id;
  var $fb_app_secret;
  var $fb_cookie_name; 
  var $user; 

  function __construct() {
    
    $this->fb_app_id      = variable_get('facebook_app_id', '');
    $this->fb_app_secret  = variable_get('facebook_app_secret', '');
    $this->fb_cookie_name = 'fbs_' . $this->fb_app_id; 
    
    if (empty($this->fb_app_id) || empty($this->fb_app_secret)) {
      fbauth_status(FACEBOOK_KEYS_MISSING);
      return;
    }
    else {
      fbauth_status(FACEBOOK_KEYS_PRESENT);
    }
    
    $sett = (array) $this;

    fbauth_facebook_settings($sett);
    
    $this->user = $this->retrieve_user();
    
  }
  
  function retrieve_user() {
    $cookie = $this->get_fb_cookie();    
    $cookie_user = $this->parse_facebook_cookie($this->fb_app_id, $this->fb_app_secret);
    if (empty($cookie_user['access_token'])) {
      return new stdClass();
    }
    $url = 'https://graph.facebook.com/me?access_token=' . $cookie_user['access_token'];
    $response = drupal_http_request($url);
    if ($response->status_message == "OK") {
      $user = (object)json_decode($response->data);
      if (isset($user->id)) {
        $user->photo = "http://graph.facebook.com/$user->id/picture";
      }
      return $user;
    }
    else {
      setcookie ($this->fb_cookie_name, "", time() - 3600, "/");
    }
    
    return new stdClass();    
  }
  
  function parse_facebook_cookie($app_id, $application_secret) {
    $args = array();
    parse_str(trim($_COOKIE['fbs_' . $app_id], '\\"'), $args);
    ksort($args);
    $payload = '';
    foreach ($args as $key => $value) {
      if ($key != 'sig') {
        $payload .= $key . '=' . $value;
      }
    }
    if (md5($payload . $application_secret) != $args['sig']) {
      return null;
    }
    return $args;
  }

  
  function get_fb_cookie() {
    if (isset($_COOKIE[$this->fb_cookie_name])) {
      return $_COOKIE[$this->fb_cookie_name];
    }
    
    return FALSE;
  }

}